//+------------------------------------------------------------------+
//|                                                        Multi.mq4 |
//|                                Copyright  2008,   |
//|                                         mailto: urgunt@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,  "
#property link      "mailto: urgunt@gmail.com"

#define Max 4

#property indicator_separate_window
#property indicator_buffers Max

#property indicator_color1 DarkGreen
#property indicator_color2 LimeGreen
#property indicator_color3 OliveDrab
#property indicator_color4 Turquoise
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

#property indicator_level1 0.0

extern string Pair0 = "EURUSDprof";
extern string Pair1 = "GBPUSDprof";
extern string Pair2 = "AUDUSDprof";
extern string Pair3 = "NZDUSDprof";

extern color Pair0Color = DarkGreen;
extern color Pair1Color = LimeGreen;
extern color Pair2Color = OliveDrab;
extern color Pair3Color = Turquoise;

double Buf0[];
double Buf1[];
double Buf2[];
double Buf3[];
//+------------------------------------------------------------------+
int init()
{
	SetIndexBuffer(0,Buf0); SetIndexStyle(0,DRAW_SECTION, EMPTY, EMPTY, Pair0Color); SetIndexLabel(0, Pair0);
	SetIndexBuffer(1,Buf1); SetIndexStyle(1,DRAW_SECTION, EMPTY, EMPTY, Pair1Color); SetIndexLabel(1, Pair1);
	SetIndexBuffer(2,Buf2); SetIndexStyle(2,DRAW_SECTION, EMPTY, EMPTY, Pair2Color); SetIndexLabel(2, Pair2);
	SetIndexBuffer(3,Buf3); SetIndexStyle(3,DRAW_SECTION, EMPTY, EMPTY, Pair3Color); SetIndexLabel(3, Pair3);
	return(0);
}
//+------------------------------------------------------------------+
int deinit() { return(0); }
//+------------------------------------------------------------------+
int start()
{
	string Pair[Max]; //       
	Pair[0]=Pair0; Pair[1]=Pair1; Pair[2]=Pair2; Pair[3]=Pair3; 
	color PairClr[Max];  //       
   PairClr[0]=Pair0Color; PairClr[1]=Pair1Color; PairClr[2]=Pair2Color; PairClr[3]=Pair3Color;

	int bar0, bar1; string str; datetime time0, time;
	int i, j, k, delta;
	double pc0, pc, a;
	int bar=iBars(Pair[0], 0); for (j=1; j<Max; j++)	bar=MathMin(bar, iBars(Pair[j], 0)); //    
	for (i=0; i<bar; i++)
	{
		time=iTime(Symbol(), 0, i); //    (   )
		//    
		k=0; bar1=0; while (k<Max && bar1!=-1)  { bar1=iBarShift(Pair[k], 0, time, true);  k++; }
		if (bar1==-1) continue;

		str=TimeYear(time)+"."+TimeMonth(time)+"."+TimeDay(time);	time0=StrToTime(str);
		//   
		k=0; bar0=0; while (k<Max && bar0!=-1)  { bar0=iBarShift(Pair[k], 0, time0, true);  k++; }
		if (bar0==-1) continue;

		//   
		k=0; pc0=1;	while (k<Max && pc0!=0)  { pc0=iClose(Pair[k], 0, bar0+1);  k++; }
		if (pc0==0) continue;
		for (j=0; j<Max; j++)
		{
			bar0=iBarShift(Pair[j], 0, time0, true); bar1=iBarShift(Pair[j], 0, time, true);
			delta=iBarShift(Symbol(), 0, time, true)-bar1;
			pc0=iClose(Pair[j], 0, bar0+1); pc=iClose(Pair[j], 0, bar1);
			a=pc/pc0*100-100;
			if (j==0) if (Pair[j]==Symbol()) Buf0[bar1]=a; else Buf0[bar1+delta]=a; 
			if (j==1) if (Pair[j]==Symbol()) Buf1[bar1]=a; else Buf1[bar1+delta]=a; 
			if (j==2) if (Pair[j]==Symbol()) Buf2[bar1]=a; else Buf2[bar1+delta]=a; 
			if (j==3) if (Pair[j]==Symbol()) Buf3[bar1]=a; else Buf3[bar1+delta]=a; 
		}
	}
	int w=WindowFind("!MultiXU");	if (w==-1) w=0;
	for (j=0; j<Max; j++)
		if (ObjectFind(Pair[j])==-1)
		{
			ObjectCreate(Pair[j], OBJ_LABEL, w, 0, 0); ObjectSet(Pair[j], OBJPROP_CORNER, 1);
			ObjectSet(Pair[j], OBJPROP_XDISTANCE, 1); ObjectSet(Pair[j], OBJPROP_YDISTANCE, 1+15*j); 
			ObjectSetText(Pair[j], Pair[j], 8, "Arial"); ObjectSet(Pair[j], OBJPROP_COLOR, PairClr[j]);
		}
	return(0);
}

